package top.daxian1218.dust.db;

import top.daxian1218.dust.db.base.DbAccess;
import java.util.ArrayList;
import java.util.List;

/**
 * dustDb的配置文件
 *
 * @author hst
 */
public class DustDbProperties {
    private String dateTimeFormatter;
    private List<DbAccess> dbList = new ArrayList<>();
    private String poolName;
    private String dbName;

    private Long workId;

    private Long datacenterId;

    private Tenant tenant = new Tenant();
    private Dict dict = new Dict();
    private LogSql logSql = new LogSql();

    public String getPoolName() {
        return poolName;
    }

    public void setPoolName(String poolName) {
        this.poolName = poolName;
    }

    public List<DbAccess> getDbList() {
        return dbList;
    }

    public void setDbList(List<DbAccess> dbList) {
        this.dbList = dbList;
    }

    public String getDateTimeFormatter() {
        return dateTimeFormatter;
    }

    public void setDateTimeFormatter(String dateTimeFormatter) {
        this.dateTimeFormatter = dateTimeFormatter;
    }

    public Tenant getTenant() {
        return tenant;
    }

    public void setTenant(Tenant tenant) {
        this.tenant = tenant;
    }

    public Dict getDict() {
        return dict;
    }

    public void setDict(Dict dict) {
        this.dict = dict;
    }

    public String getDbName() {
        return dbName;
    }

    public void setDbName(String dbName) {
        this.dbName = dbName;
    }

    public LogSql getLogSql() {
        return logSql;
    }

    public void setLogSql(LogSql logSql) {
        this.logSql = logSql;
    }

    public Long getDatacenterId() {
        return datacenterId;
    }

    public void setDatacenterId(Long datacenterId) {
        this.datacenterId = datacenterId;
    }

    public Long getWorkId() {
        return workId;
    }

    public void setWorkId(Long workId) {
        this.workId = workId;
    }

    public static class Tenant {
        private String dbName;

        public String getDbName() {
            return dbName;
        }

        public void setDbName(String dbName) {
            this.dbName = dbName;
        }
    }

    public static class LogSql {
        private boolean enable;
        private String dbName;

        public boolean isEnable() {
            return enable;
        }

        public void setEnable(boolean enable) {
            this.enable = enable;
        }

        public String getDbName() {
            return dbName;
        }

        public void setDbName(String dbName) {
            this.dbName = dbName;
        }
    }

    public static class Dict {
        private String dbName = DbConstants.DEFAULT_DB_NAME;
        private String containerClass;
        private String defaultApp;
        private boolean debug;
        private boolean noCache;

        public String getDbName() {
            return dbName;
        }

        public void setDbName(String dbName) {
            this.dbName = dbName;
        }

        public String getContainerClass() {
            return containerClass;
        }

        public void setContainerClass(String containerClass) {
            this.containerClass = containerClass;
        }

        public String getDefaultApp() {
            return defaultApp;
        }

        public void setDefaultApp(String defaultApp) {
            this.defaultApp = defaultApp;
        }

        public boolean isDebug() {
            return debug;
        }

        public void setDebug(boolean debug) {
            this.debug = debug;
        }

        public boolean isNoCache() {
            return noCache;
        }

        public void setNoCache(boolean noCache) {
            this.noCache = noCache;
        }
    }


}
