package top.daxian1218.dust.db.base;

import top.daxian1218.dust.db.DustDbException;
import top.daxian1218.dust.db.sql.HSqlCommand;

import java.sql.ResultSet;
import java.util.function.Function;

/**
 * 定义数据库操作的数据库接口
 * <p>支持基本增删改查</p>
 * @author hst
 */
public interface IDbOperations {

    /**
     * 查询数据
     * @param cmd
     * @return
     * @throws DustDbException
     */
    <T> T query(HDataCommand cmd, Function<ResultSet, T> readerHandler) throws DustDbException;


    /**
     * 更新数据，支持修改，新增和删除操作
     * @param cmd
     * @return
     * @throws DustDbException
     */
    UpdateResult update(HDataCommand cmd) throws DustDbException;

    /**
     * 检查是否支持对应的数据库操作
     * <p>适配器会从工厂选择使用的{@link IDbOperations}</p>
     * @param dbType
     * @return
     */
    boolean isSupport(String dbType);
}