package top.daxian1218.dust.db.cache;

import java.util.List;
import java.util.Map;

/**
 * 缓存定义接口
 * @author hst
 */
public interface ICache {

    /**
     * 设置缓存值
     * @param key
     * @param value
     */
    void put(String key, Object value);

    /**
     * 设置多值
     * @param key
     * @param value
     */
    void put(Map<String, Object> keyValues);

    /**
     * 获取值
     * @param key
     * @return
     */
    Object get(String key);

    /**
     * 检查键是否存在
     * @param key
     * @return
     */
    boolean exists(String key);

    /**
     * 清空键列表
     */
    void clear();

    /**
     * 缓存键列表
     * @return
     */
    List<String> keys();


    /**
     * 移除键值
     * @param keys
     */
    void evict(String ...keys);

}
