package top.daxian1218.dust.db.cache;

import java.util.List;

/**
 * 缓存管理器接口
 * @author hst
 */
public interface ICacheManager {

    /**
     * 根据名字获取缓存
     * @param name
     * @return
     */
    ICache getCache(String name);

    /**
     * 获取缓存名称
     * @return
     */
    List<String> getCacheNames();

    /**
     * 注册新的缓存处理单元
     * @param name
     * @param cache
     */
    void register(String name ,ICache cache);

    /**
     * 清空缓存
     * @param name 为空，则清空所有缓存
     */
    void flush(String name);
}
