package top.daxian1218.dust.db.cache;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;
import java.util.stream.Stream;

/**
 * 内存缓存
 * @author hst
 */
public class SimpleMemoryCache implements ICache {

    private final ConcurrentHashMap<String, Object> data = new ConcurrentHashMap<>();

    @Override
    public void put(String key, Object value) {
        data.put(key, value);
    }

    @Override
    public void put(Map<String, Object> keyValues) {
        data.putAll(keyValues);
    }

    @Override
    public Object get(String key) {
        return data.get(key);
    }

    @Override
    public boolean exists(String key) {
        return data.containsKey(key);
    }

    @Override
    public void clear() {
        data.clear();
    }

    @Override
    public List<String> keys() {
        return Collections.list(data.keys());
    }

    @Override
    public void evict(String... keys) {
        for (String key : keys) {
            data.remove(key);
        }
    }
}
