package top.daxian1218.dust.db.dict;

import com.alibaba.fastjson.JSONObject;
import org.apache.commons.lang3.StringUtils;
import top.daxian1218.dust.commons.generic.Preconditions;
import top.daxian1218.dust.db.DbAdapterManager;
import top.daxian1218.dust.db.DictGlobalConfig;

/**
 * @author hst on 2020-8-1.
 */
public class CacheDictObjContainer extends DictObjContainer {

    public CacheDictObjContainer(DbAdapterManager dbAdapterManager) {
        super(dbAdapterManager);
    }

    public long getObjId(String app, String code) {
        long id = DictCache.getInstance().getObjIdFromCache(app,code);
        if (id > 0) {
            return id;
        }

        long objId = super.getObjId(app, code);
        DictCache.getInstance().saveObjIdToCache(objId, app, code);
        return objId;
    }

    @Override
    public top.daxian1218.dust.db.dict.DictObj load(top.daxian1218.dust.db.dict.DictObj obj) {
        Preconditions.checkNotNull(obj);
        if (obj.getId() <= 0) {
            if (StringUtils.isEmpty(obj.getCode())) {
                throw new DustDictException("id or code of obj is not set");
            }

            if (StringUtils.isEmpty(obj.getAppCode())) {
                obj.setAppCode(DictGlobalConfig.Instance.getDefaultApp());
            }

            obj.setId(getObjId(obj.getAppCode(), obj.getCode()));
        }

        JSONObject jsonOfObj = DictCache.getInstance().getCacheSchemaJson(obj.getId());
        if (jsonOfObj == null) {
            jsonOfObj = getDictObjSchema(obj.getId());
            DictCache.getInstance().saveObjSchemeToCache(jsonOfObj);
        }

        obj.parseJson(jsonOfObj);
        return obj;
    }


}
