package top.daxian1218.dust.db.dict;

import top.daxian1218.dust.commons.util.TypeUtil;

import java.util.HashMap;
import java.util.Map;

/**
 * @author hst
 */
public class DictPropertyCollection {
    private final Map<String, String> data = new HashMap<>(0);

    public String get(String key) {
        return data.getOrDefault(key, null);
    }

    public Boolean getBoolean(String key) {
        return data.containsKey(key);
    }

    public int getInt(String key) {
        return TypeUtil.toInteger(get(key));
    }

    public void set(String key, String value) {
        data.put(key, value);
    }

    public void remove(String key)
    {
        data.remove(key);
    }

    public void add(String key, Object value)
    {
        data.put(key, TypeUtil.toString(value));
    }

    public void clear()
    {
        data.clear();
    }

    public boolean contain(String key) {
        return  data.containsKey(key);
    }
}
