package top.daxian1218.dust.db.dict;

/**
 * @author hst
 */
public interface IVariableHandler {

    /**
     * 默认值，根据列信息和行信息，返回合适的默认值
     * @param dc
     * @param row
     * @return
     */
    Object getDefaultValue(DictObjColumn dc, DictObjRow row);

    /**
     * 更新值，当行信息更新时，需要更新的值，如修改时间
     * @param dc
     * @param row
     * @return
     */
    Object getUpdateValue(DictObjColumn dc, DictObjRow row);

    /**
     * 根据变量名称返回变量值
     * @param name
     * @return
     */
    Object getVariable(String name);

    /**
     * 已处理
     * @param name
     * @return
     */
    boolean isHandled(String name);
}
