package top.daxian1218.dust.db.dict.condition.expressions;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import top.daxian1218.dust.db.dict.condition.DictExpression;
import top.daxian1218.dust.db.sql.HSqlCommand;

public class CommandExpression extends DictExpression {

    HSqlCommand cmd;

    public CommandExpression(HSqlCommand cmd) {
        this.cmd = cmd;
    }

    public HSqlCommand getCommand() {
        return this.cmd;
    }

    @Override
    public DictExpression parse(JSONObject jsonObject) {
        cmd = new HSqlCommand();
        cmd.appendSql(jsonObject.getString("sql"));
        cmd.appendWhere(jsonObject.getString("where"));

        JSONArray params = jsonObject.getJSONArray("params");
        params.forEach(p -> {
            if (p instanceof JSONObject) {
                JSONObject jo = (JSONObject) p;
                cmd.setParameter(jo.getString("key"), jo.get("value"));
            }
        });

        return this;
    }

    @Override
    public JSONObject toJson() {
        JSONObject json = new JSONObject();
        json.put("sql", cmd.getCommandText());
        json.put("where", cmd.getWhere());

        JSONArray jParams = new JSONArray();
        json.put("params", jParams);
        cmd.getParameters().forEachKey(k -> {
            JSONObject kv = new JSONObject();
            kv.put("key", cmd.getParameter(k));
            kv.put("value", cmd.getParameter(k));
            jParams.add(kv);
        });

        return json;
    }
}
