package top.daxian1218.dust.db.dict.condition.expressions;

import com.alibaba.fastjson.JSONObject;
import org.apache.commons.lang3.StringUtils;
import top.daxian1218.dust.commons.generic.Preconditions;
import top.daxian1218.dust.db.dict.DustDictException;
import top.daxian1218.dust.db.dict.condition.DictExpression;

/**
 * @author hst
 */
public class SqlExpression extends DictExpression {

    private String sql;

    public SqlExpression(String sql) {
        Preconditions.checkNotEmpty(sql);

        this.sql = sql;
    }

    public SqlExpression() {
    }

    public String getSql() {
        return sql;
    }

    public void setSql(String sql) {
        this.sql = sql;
    }

    @Override
    public DictExpression parse(JSONObject jsonObject) {
        Preconditions.checkNotNull(jsonObject);

        if (jsonObject.containsKey("type"))
        {
            String strType = jsonObject.getString("type");
            if (!StringUtils.equals(strType, SqlExpression.class.getSimpleName())) {
                throw new DustDictException("Node type of json not compatible ");
            }
        }

        sql = jsonObject.getString("sql");
        return this;
    }

    @Override
    public JSONObject toJson() {
        JSONObject jo = new JSONObject();
        jo.put("sql", sql);
        jo.put("type", SqlExpression.class.getSimpleName());
        return null;
    }
}
