package top.daxian1218.dust.db.dict.condition.expressions;

import com.alibaba.fastjson.JSONObject;
import org.apache.commons.lang3.StringUtils;
import top.daxian1218.dust.commons.generic.Preconditions;
import top.daxian1218.dust.db.dict.DataType;
import top.daxian1218.dust.db.dict.DustDictException;
import top.daxian1218.dust.db.dict.condition.DictExpression;
import top.daxian1218.dust.db.dict.utils.DataUtil;

/**
 * @author hst
 */
public class ValueExpression extends DictExpression {
    private Object value;
    private DataType dataType = DataType.STRING;

    public ValueExpression() {

    }

    public ValueExpression(Object value) {
        this.value = value;
    }

    public DataType getDataType() {
        return dataType;
    }

    public ValueExpression setDataType(DataType dataType) {
        this.dataType = dataType;
        return this;
    }

    public Object getValue() {
        return DataUtil.toTypeValue(dataType, value);
    }

    @Override
    public DictExpression parse(JSONObject jsonObject) {
        Preconditions.checkNotNull(jsonObject);

        if (jsonObject.containsKey("type")) {
            String strType = jsonObject.getString("type");
            if (!StringUtils.equals(strType, ValueExpression.class.getSimpleName())) {
                throw new DustDictException("类型不符合");
            }
        }

        value = jsonObject.get("value");
        return this;
    }

    @Override
    public JSONObject toJson() {
        JSONObject json = new JSONObject();
        json.put("type", ValueExpression.class.getSimpleName());
        json.put("value", getValue());
        return json;
    }
}
