package top.daxian1218.dust.db.dict.utils;

import top.daxian1218.dust.commons.util.TypeUtil;
import top.daxian1218.dust.db.dict.DataType;

import java.sql.Timestamp;
import java.util.Date;

/**
 * 数据类型转换
 *
 * @author hst
 */
public class DataUtil {
    public static Object toTypeValue(DataType dataType, Object o) {
        switch (dataType) {
            case BOOLEAN:
                return TypeUtil.toBoolean(o);
            case BINARY:
                return TypeUtil.toBytes(o);
            case INT:
                return TypeUtil.toInteger(o);
            case UBIGINT:
                return TypeUtil.toLong(o);
            case NUMBER:
                return TypeUtil.toDouble(o);
            case DATE:
                return TypeUtil.toDateTime(o);
            case CURRENCY:
                return TypeUtil.toDecimal(o);
            default:
                return TypeUtil.toString(o);
        }
    }

    public static DataType getDataType(String cls) {

        switch (cls) {
            case "Integer":
            case "java.lang.Integer":
            case "int":
            case "Short":
            case "java.lang.Short":
            case "short":
                return DataType.INT;
            case "java.lang.Boolean":
            case "Boolean":
            case "boolean":
            case "byte":
            case "java.lang.Byte":
            case "Byte":
                return DataType.BOOLEAN;
            case "java.lang.Long":
            case "Long":
            case "long":
                return DataType.UBIGINT;
            case "java.lang.Double":
            case "Double":
            case "double":
            case "java.math.BigDecimal":
            case "BigDecimal":
            case "java.lang.Float":
            case "Float":
            case "float":
                return DataType.NUMBER;
            case "java.util.Date":
            case "java.sql.Date":
            case "Date":
            case "Timestamp":
            case "java.sql.Timestamp":
                return DataType.DATE;
            case "byte[]":
            case "Byte[]":
            case "[Ljava.lang.Byte;":
                return DataType.BINARY;
            default:
                return DataType.STRING;
        }
    }

    public static <T> DataType getDataType(Class<T> cls) {
        return getDataType(cls.getName());
    }
}
