package top.daxian1218.dust.db.sql;

/**
 * 存储过程参数枚举
 * <ul>
 *     <li>无</li>
 *     <li>输入</li>
 *     <li>输出</li>
 *     <li>输入输出</li>
 *     <li>返回值</li>
 *     <li>错误信息</li>
 *     <li>错误码</li>
 *     <li>日志详情</li>
 *     <li>函数返回值</li>
 * </ul>
 * @author hst
 */
public enum ProcParaType {
    /**
     * 无
     */
    NONE("0"),
    /**
     * 输入
     */
    INPUT("1"),
    /**
     * 输出
     */
    OUTPUT("2"),
    /**
     * 输入输出
     */
    INOUT("3"),
    /**
     * 返回值
     */
    RETURN("4"),
    /**
     * 错误信息
     */
    ERRMSG("5"),
    /**
     * 错误码
     */
    ERRCODE("6"),
    /**
     * 日志详情
     */
    LOGERRMSG("7"),
    /**
     * 函数返回值
     */
    FUNCRESULT("8");

    private String value;

    ProcParaType(String value) {
        this.value = value;
    }

    @Override
    public String toString() {

        return this.value;
    }

}
