package top.daxian1218.dust.db.sql;

import org.apache.commons.lang3.StringUtils;
import top.daxian1218.dust.db.base.IDataAdapter;
import top.daxian1218.dust.db.sql.pool.SqlResource;

import java.util.HashMap;
import java.util.Map;

/**
 * Sql资源获取器
 */
public class SQLs {

    public static String get(String name, IDataAdapter adapter) {
        String dbType = adapter.getDbType();
        String sql = StringUtils.EMPTY;
        Map<String, String> mapSql = SqlResource.getDbSqlRes(dbType);
        if (mapSql.containsKey(name)) {
            sql = mapSql.get(name);
        }

        if (StringUtils.isEmpty(sql)) {
            mapSql = SqlResource.getDefaultDbSqlRes();
            sql = mapSql.getOrDefault(name, StringUtils.EMPTY);
        }

        return sql;
    }

    public static String get(String name, IDataAdapter adapter, String defaultSql) {
        String dbType = adapter.getDbType();
        Map<String, String> mapSql = SqlResource.getDbSqlRes(dbType);
        if (mapSql.containsKey(dbType)) {
            return mapSql.getOrDefault(name, defaultSql);
        }

        return defaultSql;
    }
}
