package top.daxian1218.dust.db.sql.command;

import org.apache.commons.lang3.StringUtils;
import top.daxian1218.dust.db.DustDbException;
import top.daxian1218.dust.db.sql.HSqlCommand;
import top.daxian1218.dust.db.sql.SqlCommandType;

/**
 * @author hst
 */
public class HDeleteSqlCommand extends HSqlCommand {
    public HDeleteSqlCommand(String table) {
        appendSql(table);
        this.setCommandType(SqlCommandType.EXEC);
    }

    @Override
    protected String combineSql() {
        if (StringUtils.isEmpty(getCommandText())) {
            throw new DustDbException("table name is empty");
        }

        StringBuilder sb = new StringBuilder("DELETE FROM " + getCommandText());
        this.setWhere(StringUtils.EMPTY);
        fields.forEach(col ->
        {
            if (StringUtils.isEmpty(col.getName()) || col.getName().startsWith(PrefixOld)) {
                return;
            }

            if (col.isPrimaryKey()) {
                appendWhere(col.getName() + "=:" + col.getName());
            }
        });

        if (hasWhere()) {

            sb.append(" WHERE ");
            sb.append(getWhere());
        } else {
            throw new DustDbException("Delete Command must have primary key");
        }

        return sb.toString();
    }
}
