package top.daxian1218.dust.db.sql.command;

import org.apache.commons.lang3.StringUtils;
import top.daxian1218.dust.commons.data.HDataColumn;
import top.daxian1218.dust.db.DustDbException;
import top.daxian1218.dust.db.sql.HSqlCommand;
import top.daxian1218.dust.db.sql.SqlCommandType;

/**
 * @author hst
 */
public class HInsertSqlCommand extends HSqlCommand {
    public HInsertSqlCommand(String table) {
        resetSql();
        appendSql(table);
        this.setCommandType(SqlCommandType.EXEC);
    }

    @Override
    protected String combineSql() {
        if (StringUtils.isEmpty(getCommandText())) {
            throw new DustDbException("table name is empty");
        }

        StringBuilder sb = new StringBuilder("INSERT INTO " + getCommandText() + "(");
        StringBuilder sbValues = new StringBuilder();
        boolean needComma = false;
        for(HDataColumn col : fields) {
            if (needComma) {
                sb.append(",");
                sbValues.append(",");
            } else {
                needComma = true;
            }

            sb.append(col.getName());

            // 如果列信息定义了配置的值，则不需要使用动态值
            if (col.getProperties().contains(DbValueKey)) {
                sbValues.append(col.getProperties().get(DbValueKey));
            } else {
                sbValues.append(":").append(col.getName());
            }
        }

        sb.append(") VALUES (");
        sb.append(sbValues);
        sb.append(")");
        return sb.toString();
    }
}
