package top.daxian1218.dust.db.sql.pool;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import top.daxian1218.dust.db.DustDbException;
import top.daxian1218.dust.db.base.DbAccess;
import top.daxian1218.dust.db.sql.IDataSource;

import javax.sql.DataSource;
import java.sql.Connection;
import java.sql.SQLException;

/**
 * @author hst
 */
public class DustDataSource implements IDataSource {
    static Logger logger = LoggerFactory.getLogger(DustDataSource.class);

    private DbAccess dbAccess;
    private DataSource poolDataSource;

    public DustDataSource(DbAccess dbAccess, DataSource poolDataSource) {
        this.dbAccess = dbAccess;
        this.poolDataSource = poolDataSource;
    }


    @Override
    public Connection getConnection() {
        try {
            return poolDataSource.getConnection();
        } catch (SQLException ex) {
            throw new DustDbException("获取数据库连接失败", null, ex);
        }
    }

    @Override
    public DbAccess getDbAccess() {
        return dbAccess;
    }
}
