package top.daxian1218.dust.db.sql.pool;

import org.apache.commons.lang3.StringUtils;
import top.daxian1218.dust.commons.exception.DustSystemException;

import java.util.Collections;
import java.util.HashMap;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;

public class SqlResource {
    private static final Map<String, Map<String, String>> DATA = new ConcurrentHashMap<>();
    public static final String DEFAULT = "default";
    public static void addDbSqlRes(String dbType, Map<String, String> sqls) {
        if (StringUtils.isEmpty(dbType)) {
            throw new IllegalArgumentException("dbType");
        }

        if (sqls == null) {
            throw new IllegalArgumentException("sqls");
        }

        if (DATA.containsKey(dbType)) {
            DATA.get(dbType).putAll(sqls);
        } else {
            DATA.put(dbType, new HashMap<>(sqls));
        }
    }

    public static Map<String, String> getDbSqlRes(String dbType) {
        return DATA.containsKey(dbType) ? Collections.unmodifiableMap(DATA.get(dbType)): Collections.unmodifiableMap(new HashMap<>());
    }

    public static Map<String, String> getDefaultDbSqlRes() {
        return getDbSqlRes(DEFAULT);
    }
}
