package top.daxian1218.dust.db.support.clickhouse;

import org.apache.commons.lang3.StringUtils;
import top.daxian1218.dust.db.base.DbTypes;
import top.daxian1218.dust.db.sql.HSqlCommand;
import top.daxian1218.dust.db.sql.SqlDbOperations;

import java.util.List;

public class ClickHouseDbOperations extends SqlDbOperations {
    @Override
    protected String getSql(HSqlCommand cmd, boolean isQuery) {
        String sql = cmd.getDbExecuteSql((v, i) -> "?");
        if (isQuery && cmd.getPageSize() > 0) {
            return sql + " LIMIT ? OFFSET ?";
        }

        return sql;
    }

    @Override
    public void setPageParameter(List<Object> parameters, HSqlCommand cmd) {
        parameters.add(cmd.getPageSize());
        parameters.add(cmd.getBeginIndex());
    }

    @Override
    public boolean isSupport(String dbType) {
        return StringUtils.equals(dbType, DbTypes.ClickHouse);
    }
}
