package top.daxian1218.dust.db.support.memory;

import com.alibaba.fastjson.JSONObject;
import org.apache.commons.lang3.StringUtils;
import top.daxian1218.dust.commons.generic.Preconditions;
import top.daxian1218.dust.db.cache.SimpleMemoryCache;
import top.daxian1218.dust.db.dict.DictObj;
import top.daxian1218.dust.db.dict.DictObjContainer;
import top.daxian1218.dust.db.dict.DustDictException;

/**
 * @author hst on 2020-8-1.
 */
public class DictObjContainer4Mem extends DictObjContainer {
    private final SimpleMemoryCache cache = new SimpleMemoryCache();

    public DictObjContainer4Mem() {
        super(null);
    }

    @Override
    public DictObj load(DictObj obj) {
        Preconditions.checkNotNull(obj);
        if (obj.getId() > 0) {
            Object value = cache.get(getDictIdKey(obj.getId()));
            if (value instanceof JSONObject) {
                return obj.parseJson((JSONObject) value);
            }
            throw new DustDictException("字典不存在");
        }

        if (!StringUtils.isEmpty(obj.getCode())) {
            String key = getDictKey(obj.getCode(), obj.getAppCode());
            if (cache.exists(key)) {
                long id = (long) cache.get(key);
                return obj.parseJson((JSONObject) cache.get(getDictIdKey(id)));
            }

            throw new DustDictException(key + "字典不存在");
        }

        throw new DustDictException("无效的字典");
    }

    private String getDictIdKey(long id) {
        return String.format("DictObj:Id:%s", id);
    }

    private String getDictKey(String code, String appCode) {
        String app = StringUtils.isEmpty(appCode) ? "NA" : appCode;
        return String.format("DictObj:Code:%s:%s", code, app);
    }
}
