package top.daxian1218.dust.db.support.mssql;

import top.daxian1218.dust.db.base.DbTypes;
import top.daxian1218.dust.db.sql.SqlDbOperations;
import top.daxian1218.dust.db.sql.HSqlCommand;
import org.apache.commons.lang3.StringUtils;

/**
 * 适配SqlServer数据库操作
 * @author hst on 2020-8-1.
 */
public class SqlServerDbOperations extends SqlDbOperations {

    @Override
    protected String getSql(HSqlCommand cmd, boolean isQuery) {
        boolean ignoreOrder = cmd.isIgnoreOrder();
        if (isQuery && cmd.getPageSize() > 0) {
            cmd.setIgnoreOrder(true);
            String sql = cmd.getDbExecuteSql((v, i) -> "?");
            String sqlOrderBy = cmd.getOrder();
            if (StringUtils.isEmpty(sqlOrderBy)) {
                sqlOrderBy = "id";
            }

            String execSql = "SELECT * FROM (SELECT row_number() OVER (ORDER BY "+ sqlOrderBy +
                    ") AS row_num_ , * FROM (" + sql + ") data_row_ ) row_ " +
                    "WHERE row_num_ >= ? AND row_num_ <= ?";
            cmd.setIgnoreOrder(ignoreOrder);
            return execSql;
        } else {
            cmd.setIgnoreOrder(false);
            String sql = cmd.getDbExecuteSql((v, i) -> "?");
            cmd.setIgnoreOrder(ignoreOrder);
            return sql;
        }
    }

    @Override
    public boolean isSupport(String dbType) {
        return StringUtils.equals(dbType, DbTypes.Mssql);
    }

}
