package top.daxian1218.dust.db.support.mysql;

import org.apache.commons.lang3.StringUtils;
import top.daxian1218.dust.db.base.DbTypes;
import top.daxian1218.dust.db.sql.SqlDbOperations;
import top.daxian1218.dust.db.sql.HSqlCommand;

/**
 * 支持MySql的DataBase实现
 * @author hst
 */
public class MySqlDbOperations extends SqlDbOperations {
    @Override
    protected String getSql(HSqlCommand cmd, boolean isQuery) {
        String sql = cmd.getDbExecuteSql((v, i) -> "?");
        if (isQuery && cmd.getPageSize() > 0) {
            return sql + " limit ?,?";
        }

        return sql;
    }

    @Override
    public boolean isSupport(String dbType) {
        return StringUtils.equals(dbType, DbTypes.Mysql);
    }
}
