package top.daxian1218.dust.db.support.oracle.exception;

import org.apache.commons.lang3.ClassUtils;
import top.daxian1218.dust.db.sql.IExceptionFactory;
import top.daxian1218.dust.db.sql.IExceptionHandler;

import java.util.ArrayList;
import java.util.List;

public class OracleExceptionFactory implements IExceptionFactory {

    private final List<IExceptionHandler> handlerList = new ArrayList<>();

    public OracleExceptionFactory() {
        handlerList.add(new Ora00001());
        handlerList.add(new Ora00018());
        handlerList.add(new Ora00067());
        handlerList.add(new Ora00068());
        handlerList.add(new Ora01427());
        handlerList.add(new Ora12899());
    }

    @Override
    public IExceptionHandler getHandler(String message) {
        return handlerList.stream().filter(h -> h.support(message)).findFirst().orElse(new DefaultHandler());
    }
}
